module constants_and_variables
      ! was include file pparm.inc

      ! NCMPTS - number of przm compartments
      ! the dimension for 'NCMPTS' must be at least one number larger
      ! than the number of compartments that are being simulated.

      ! 11/11/96 by jmc
      ! if 'NCMPTS' is increased, NPII must also increase. the new
      ! value of NPII should be set equal to NCMPTS*NUM. NUM is defined
      ! in SUBROUTINE INITL in RSINP2.FOR at line 2633 (line 558 of INITL).
      ! NUM is currently set equal to 4.
      !
      ! note if NPII value is changed, write statements in lines 106-123
      ! of subroutine RSTPT1 and read statements in lines 120-138 of
      ! subroutine RSTGT1 for variable CC need to be modified accordingly.
      implicit none
      save
      integer :: data_number = 0
      integer :: data_date(100) = 0
      real    :: data_erosion(100) = 0.0
      real    :: data_runoff(100) = 0.0
      real    :: data_mgsed(100) = 0.0
      real    :: data_mgh2o(100) = 0.0
      
      real    :: model_erosion(100) = 0.0
      real    :: model_runoff(100) = -0.0
      real    :: model_mg_ro(100) = 0.0
      real    :: model_mg_er(100) = 0.0
      
      
      Integer, Parameter :: NCMPTS = 500
      Integer, Parameter :: NAPP = 800           ! NAPP - number of pesticides applications    
      Integer, Parameter :: NC = 5               ! NC - Maximum number of crops
      Integer, Parameter :: MXCPD = 100          ! maximum number of cropping periods 
      integer, parameter :: maxFileLength = 300  ! Maximum path and File name length
      integer, parameter :: max_horizons = 10    ! maximum number of soil horizons
      
      

      integer, parameter ::  PRZMinputUnit  = 51
      integer, parameter ::  MetFileUnit    = 52
      integer, parameter ::  TimeSeriesUnit = 54
      integer, parameter ::  EchoFileUnit   = 56
      integer, parameter ::  CalibrationDataUnit = 57
      Character(Len = maxFileLength) :: CalibrationFilename
      Character(Len = maxFileLength) :: RunFilePath = ''
      
      integer, parameter :: Num_hydro_factors = 100
      
      real,parameter :: DELT = 1.0
      
      !Depths
      real    :: soil_depth(NCMPTS)  !vector of soil depths
      integer :: NCOM2              !total compartments   
      integer :: NCOMRZ             ! Number of Compartments in the Root Zone


      
      
      integer :: NCOM1  !holds the lowest relavant evaopration node for each day
      integer :: NCOM0  !holds the node of lowest evapotation (per anetd)

      Real, Parameter :: cam123_soil_depth = 4.0 ! cm  Default pesticide incorporation depth
      real, parameter :: CN_moisture_depth = 10.0  !depth of soil moisture for CN calculations
      
      REAL :: r1
      REAL :: R0MIN  = Tiny(r1)
                   
      logical :: really_not_thrufl  !flag to prevent washoff of undercanopy irrigation in PRZM3 (not used in PRZM5)
      real    :: canopy_flow        !flow through the canopy
      real    :: effective_rain     !total water, without consideration for canopy holdup 
      real    :: THRUFL             !total water minus canopy holdup 
      
      !***Simulation Timne **************************************************
      integer  :: ISDAY,ISMON,ISTYR !INPUT from run file, start date

      integer  :: startday         !julian day start date referenced to 1900 (note that we use two digit date, makes no difference)
      integer  :: julday1900    !the current day referenced to Jan 1, 1900
      
      
      !***PRZM5 Advanced Analysis OPtipon
      logical :: FLAG1      !True if Freundlich
      logical :: FLAG2
      logical :: FLAG3
   
      logical :: FLAG4
      logical :: calibrationFlag =.FALSE.
      
      !*****Pesticide Properties ******************
      integer :: application_date(NAPP)
      
      real :: DWRAT1(3,NCMPTS)  !these are put imeediatelt into variables below
      real :: DSRAT1(3,NCMPTS)
      real :: DGRAT1(3,NCMPTS)
      
      real :: DWRATE(3,NCMPTS),DGRATE(3,NCMPTS),DSRATE(3,NCMPTS)
      real :: DEPI(3,NAPP)
      real :: KD(3,NCMPTS)
      real :: TAPP(3,NAPP)
      real :: APPEFF(3,NAPP)
      real :: Tband_top(3,NAPP)
      real :: PLDKRT(3)        !plant decay rate
      real :: FEXTRC(3)
      real :: DISP(3,NCMPTS)
      real :: ENPY(3)

      real :: dispCoeff(NCMPTS)  !replacement for disp(3,ncmpts)
      
      REAL :: DAIR(3)
      real :: SOILAP(3,NCMPTS)
      real :: SOL(3)
      integer :: PCMC  !signal to tell if its Koc to use
      
      
      real :: HENRYK(3)
      real :: PLVKRT(3)   !plant pesticide volatilization rate

      real :: KH(3,NCMPTS)    !henry law terms
      real :: OKH(3,NCMPTS)  
      
      integer :: KDFLAG   !Select Kd calculation
      integer :: THFLAG   !computw Wp and FC based on texture
      
      
      
      real :: k_f_input(3,max_horizons)  !input Freundlich Kf for each horizon
      real :: N_f_input(3,max_horizons)  !input Freundlich N for each horizon
      
      
      real :: k_freundlich(3,NCMPTS)  !these Kf specified for each compartment
      real :: N_freundlich(3,NCMPTS)  !these Kf specified for each compartment
      real :: kd_eff(3,NCMPTS)        !these are effective Kd specified for each compartment (linearized from Kf and N)
      real :: lowest_conc             !Below this concentration (mg/L), isotherm is approximated to be linear to prevent numerical issues
      
      
      
      
      real :: FPLOS12,FPLOS13,FPLOS23


      
      real :: SPESTR(3,NCMPTS)  !pesticide conc in pore water?
      real :: PESTR(3,NCMPTS)   !pest conc in soil mg/kg
      real :: PTRN12,PTRN13,PTRN23 !foliar transformation rates
      
      real ::  DKRW12(NCMPTS),DKRW13(NCMPTS),DKRW23(NCMPTS)
    !  real ::  DKRS12(NCMPTS),DKRS13(NCMPTS),DKRS23(NCMPTS)
      
      real :: FILTRA
      
      REAL :: UPTKF(3)         !PLANT UPTAKE FACTOR, CONVERTED TO GAMMA1 IN PLANTGROW

      
      real :: CONDUC(3)        !Some canopy volatilization parameter
      
      !****Pesticide Applications
      INTEGER :: CAM(3,NAPP)
      INTEGER :: NAPS
      real    :: PLNTAP(3)
      integer :: NCHEM
      integer :: FAM             !foliar application signal =2
      integer :: CRPAPP(3) = 0   !used to indicate to output files that the application was caused by harvest (IPSCND=1).
      
      
      REAL :: QFAC
      REAL :: TBASE
      

      real :: ELTERM(3)
      real :: ELTT       !erosion loss term
      real :: TCNC(3)    !used for outpiut only
      
      
      !****Pesticide Flux**************
      real :: DKFLUX(3,NCMPTS),ERFLUX(3),WOFLUX(3),ROFLUX(3),RZFLUX(3),SRCFLX(3,NCMPTS)
     
      real :: TRFLUX(3,NCMPTS)
      real :: TTRFLX(3),TSRCFX(3) 
      
      
      
      !*********Tridagonal Parameters**********************
 !     real(KIND = 8) ::  A(NCMPTS),B(NCMPTS),C(NCMPTS),F(NCMPTS)  !these do not need to be in module
      real ::  X(NCMPTS)
      
      !******Weather Related Variables******************
      real :: TEMP,PEVP,PRECIP,SOLRAD,WIND
      real :: PFAC,SFAC
      real :: SNOWFL
     
      
      !*******Heat transfer variables*********************
      real    :: emmiss   
      real    :: UBT
      real    :: spt(ncmpts),VHTCAP(NCMPTS),THCOND(NCMPTS)
      real    :: Albedo(13), bbt(13)
      integer :: ITFLAG,IDFLAG
      
      
      !*****Irrigation Parameters
      integer :: IRFLAG
      integer :: IRTYPE
      
      real    :: PCDEPL,RATEAP,FLEACH  !inputs
      real    :: under_canopy_irrig, over_canopy_irrig,flood_irrig  !new PRZM5 variables
      
      real    :: IRRR  !daily irrigation water, used for time series reporting only
      logical :: UserSpecifiesDepth  !True if custom depth, False if auto with root depth
      real    :: user_irrig_depth       !user-specified depth of irrigation, input value
      integer :: user_irrig_depth_node  !node for user-specified depth of irrigation, calc in INITL subroutine
      
      !*****Crop Parameters ********* 
      integer :: emergence_date(MXCPD)
      integer :: maturity_date(MXCPD)
      integer :: harvest_date(MXCPD)

      real    :: ANETD               !inputs
      real    :: CINTCP(NC)          !maximum hold up on canopy == converted to the variable DIN in the program
      real    :: COVMAX(NC)
      real    :: AMXDR(NC)
      real    :: WFMAX(NC)
      real    :: HTMAX(NC)
      integer :: Num_Crops                 !number of crops in simulation from input file
      integer :: INCROP(MXCPD)    
      integer :: INICRP
      
      integer :: RZI                 !signal that crop is growing 1=crop
      integer :: NRZCOMP             !the nodes to the bottom pf evap/root zone
      integer :: NCROP               !crop number being currently simulated
      real    :: COVER,WEIGHT,HEIGHT

      integer  :: NDCNT          !number of days into crop growth cycle
      
      integer :: IYREM(MXCPD),IYRMAT(MXCPD),IYRHAR(MXCPD)  !Array of years for emergence, matuity, harvest
 !     integer :: IEMER(MXCPD),MAT(MXCPD),IHAR(MXCPD)       !array of julian days for emergence, matuity, harvest
 
      integer :: IFSCND(3,NC)
      integer :: ncpds
      integer :: ICNCN(NC)
      integer :: IPSCND(3)  !1 = pesticide is surface applied at harvest, 2 = complet removal, 3 = left alone, 4 = bypass
       
      integer :: NCP

      
      !*****Soil Profile Parameters *****************
      integer :: NHORIZ           !input value
   !   integer :: HORIZN(NCMPTS)   !input horizon number
      
      real :: WP(NCMPTS)          !Wilting point
      real :: FC(NCMPTS)          !field capacity
      real :: DELX(NCMPTS)
      real :: THETO(NCMPTS)
      real :: BD(NCMPTS)
      real :: THETN(NCMPTS)   !THETN is actually the begining day water content
      real :: CLAY(NCMPTS)
      real :: SAND(NCMPTS)
      real :: THEFC(NCMPTS)
      real :: THEWP(NCMPTS)
      real :: OC(NCMPTS)
      real :: THKNS(NCMPTS)
    
      real :: SoilWater(NCMPTS)  !formerly SW
     ! real :: DPN(NCMPTS)
      
      integer :: Num_delx(NCMPTS) !Number of discretizations in horizon
      

      !*****Erosion Parameters *************************
      real :: AFIELD           !INPUT, field area input, hA
      real :: USLEK            !INPUT,
      real :: USLEP            !INPUT, 
      real :: USLELS           !INPUT,
      real :: HL               !INPUT,
      real :: SLP
      
      integer :: erflag         !erosion flag
      
      
            

      integer :: CN_index          !Current index for ereosion and runoff parameters, current one being used
      real    :: N1                !The current mannings n value
      real    :: CFAC              !The current c factor
      real    :: USLEC(NC,Num_hydro_factors)      !inpuit values for c facator
      real    :: MNGN(NC,Num_hydro_factors)      
      
      integer :: use_usleyears= 0  !flag to use year specific or repeating erosion/runoff factors, 1 is year specific
      integer :: NUSLEC(NC)      !number of c factors
      integer :: GDUSLEC(NC,Num_hydro_factors)  !day, these are actually local variables and dont need to be in this module.
      integer :: GMUSLEC(NC,Num_hydro_factors)  !month
      integer :: GYUSLEC(NC,Num_hydro_factors)  !year when this option is used
      
      
      
      integer :: JUSLEC(NC,Num_hydro_factors)   !julian day for each of the erosion days converted from gduslec and gmuslec
      
      
      
      
      integer :: CN_input(NC,Num_hydro_factors,3)   
      integer :: CN_2(NC,Num_hydro_factors) !Curve Number 2 read from inputs, integer because its used as index in lookup table     
      integer :: IREG        !erosion/rain intensity map region
      
      
      !******Hydrology*********
      real :: STTDET             !evaporation amount in the top 5 cm, used for temperature calculations 
      REAL :: CEVAP              !HOLDS ACTUAL PET
      real :: SMELT          !snow melt
      real :: THETH          !water content halfway between wp and fc averaged over rodepth
      real :: INABS
      
      integer :: cn_moist_node  !number of compartments that make up runff moisture depth
      
      !***Accumulators***************
      real :: THETAS(NCMPTS)   = 0.0  !saturation water content
      real :: VEL(NCMPTS)      = 0.0
      real :: ET(NCMPTS)       = 0.0 
      real :: AINF(NCMPTS)     = 0.0    !water over field capacity, i.e infiltration     
      real :: GAMMA1(3,NCMPTS) = 0.0
      real :: soil_applied_washoff(3,NCMPTS)  = 0.0    !plant washoff pesticide (i think)
      real :: runof            = 0.0
      real :: snow             = 0.0   !accumulated snow for each day
      real :: FPDLOS(3)        = 0.0   !foliar loss
      real :: FOLPST(3)        = 0.0   !foliar storage
      real :: DCOFLX(3)        = 0.0   !Pesticide outflow below soil core
      real :: SUPFLX(3)        = 0.0 
      real :: SDKFLX(3)        = 0.0 
      real :: FPVLOS(3)        = 0.0    !volatilization
      real :: FOLP0(3)         = 0.0
      real :: potential_canopy_holdup  = 0.0    !daily maximum water that the canopy can hold
      real :: CINT             = 0.0    !the actual water held on the canopy during the current day
      real :: TDET             = 0.0    !evapotranspiration in the topp ncom1 compartments
      
      real :: SEDL
   
      real :: PVFLUX(3,NCMPTS)   !daily pesticide volatilization

      real :: UPFLUX(3,NCMPTS),DFFLUX(3,NCMPTS),ADFLUX(3,NCMPTS)




!      integer :: MTR1  !some kind of comaprtment count = ncom2
      
      
      !****Miscelaneous******

      
      !CHARACTER(len=78) ::  TITLE     !INPUTused in EXAMS output files and time series
      CHARACTER(len=20) ::  PSTNAM(3) !INPUT used in EXAMS
      integer :: header = 0           !signals to write header to timeseries, a start flag
      

      integer :: current_day        !day of month
      integer :: current_month
      integer :: current_year       !taken from metfile
              
      integer  :: CFLAG                 !INPUT initial pesticide concentration conversion flag
      
      character(len=4) ::  MODE(12)     !INPUT time series plot modes
      character(len=4) :: PLNAME(12)    !INPUT Plot IDs for time series
      integer  :: IARG(12),IARG2(12)    !INPUT arguments for time series plots
      integer  :: NPLOTS                !INPUT number of time series plots
      real     :: CONST(12)             !INPUT, the user defined adjustment to the time series output
      real     :: OUTPUJ(12)
      real     :: OUTPJJ(12)
      CHARACTER(len =1) ::  INDX(12)    !plot characterizer chem 1 2 3 
      
      REAL   ::  CVNUM   !holds curve number for plotting
             
      !***** PRZM5 runoff and erosion extraction variables ****************
      real :: runoff_effic              !amount of runoff bypassing surface soil
      real :: runoff_decline            !exponential factor for interaction decline with depth
      real :: runoff_extr_depth      !depth of runoff interaction
      
      real :: erosion_decline           !exponential factor for interaction decline with depth
      real :: erosion_depth             !erosion depth
      real :: runoff_intensity(NCMPTS)  !PRZM5 uses this instead of DRI, fraction of runoff per cm depth
      real :: erosion_intensity(ncmpts)
      
      integer :: RNCMPT             !the number of compartments corresponding to the runoff extraction depth
      integer :: erosion_compt      !number of compartments for rerosion extraction
      

end module constants_and_variables