module freundlich_isotherm
    implicit none
    
    contains
    
    subroutine freundlich(chem)
      use constants_and_Variables, ONLY: lowest_conc, SPESTR, PESTR, KD,k_freundlich,N_freundlich, kd_eff,ncom2, theto,bd,thetas,kh
      integer,intent(in) :: chem
      
      ! Calculate effective Kd based on last known water concentration


      where (spestr(chem,:) > lowest_conc)
         kd_eff(chem,:)  = k_freundlich(chem,:) *SPESTR(chem,:)**(N_freundlich(chem,:)-1.0)
      elsewhere
         kd_eff(chem,:)  = k_freundlich(chem,:)*(lowest_conc)**(N_freundlich(chem,:)-1.0)
      end where
      
      
      
      
      write(87,*)lowest_conc, spestr(1,1), kd_eff(1,1),spestr(1,1) > lowest_conc
      
      
      !Recalculate the Pore Water Concentration given a new Kd and the Original total Mass

      KD(chem, 1:ncom2) = kd_eff(chem, 1:ncom2)
      

      SPESTR(CHEM,1:ncom2)= PESTR(CHEM,1:ncom2)*THETO(1:ncom2)/(THETO(1:ncom2) + KD(CHEM,1:ncom2)*BD(1:ncom2) + &
                            (THETAS(1:ncom2)-THETO(1:ncom2))*KH(CHEM,1:ncom2))
     

    end subroutine freundlich

end module freundlich_isotherm
    