module initialization
implicit none
contains

    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!     
SUBROUTINE INITL
  use constants_and_Variables, ONLY: NAPP,NC ,MXCPD, NCMPTS,spt,thcond,vhtcap,ANETD,covmax,amxdr,ncpds,wfmax,         &
        Num_Crops,INCROP,ncrop, icncn,ncp,NCOMRZ,INICRP,SoilWater,fc,wp,delx,bd,                                        &
        theto,THEFC,THEWP,SAND,CLAY,thetas, juslec,NUSLEC,theth,RNCMPT,ncom0,ncom2,     &
        DWRATE,DSRATE,DGRATE,pestr,spestr,TAPP,DISP,DKRW12,DKRW13,DKRW23,NAPS,                 &
        OKH,HENRYK,OC,NCHEM,NHORIZ,THKNS,OUTPUJ,OUTPJJ,Num_delx,                                      &
        ISTYR,ISMON,ISDAY, startday,emergence_date,harvest_date,soil_depth ,                          &
        NDCNT,RZI,CFLAG,delt, thflag, kdflag, thetn,CN_index,cfac,n1,USLEC,mngn,EchoFileUnit,application_date,   &
        cn_moist_node, runoff_effic, runoff_decline,runoff_intensity,runoff_extr_depth, &
        CAM,cam123_soil_depth,DEPI,CN_moisture_depth,erosion_intensity,erosion_decline,erosion_depth , erosion_compt, &
        GYUSLEC,GMUSLEC,GDUSLEC,use_usleyears, &
        user_irrig_depth_node, UserSpecifiesDepth,user_irrig_depth,  k_f_input, N_f_input,k_freundlich, N_freundlich, KD
                        
  use utilities
 ! use oldPRZM3
  implicit none
  
  REAL              RZD,TTHKNS,MODFC,T
  REAL              U     
  INTEGER           i,J,JB,IB,IBM1
  INTEGER           K

  LOGICAL           FATAL

  real            :: delx_avg_depth
  integer         :: startday_doy !  startday day of year  number of days past Jan 1, used for erosion
  integer         :: day_difference, smallest_difference
  real, parameter :: tol = 0.01  !some kind of tolerance for compartment size, Needs checking

  integer :: start, xend

    CHARACTER(len = 80):: note  !used for sending error messages
   
    call Calculate_CurveNumbers_1and3  !this is only used for przm3 calculations

    ! *** Populate the Delx Vector and Kf & N *******
    start = 1
    Xend = 0
    delx(1:num_delx(1)) = thkns(1)/num_delx(1)
     
    do i=1, nhoriz
        xend = start +num_delx(i)-1
        delx(start:xend) = thkns(i)/num_delx(i) 
         do K=1, NCHEM
             k_freundlich(k, start:xend) = k_f_input(k,i)
             N_freundlich(k, start:xend) = N_f_input(k,i)
             KD(k, start:xend)= k_f_input(k,i)  !Only needed if we want to completely bypass freundlich routine. Used for testing
          end do
    
        start = xend+1
    end do
    
    
    

    
    
    !*************************************  

    NCOM2 = sum(num_delx(1:nhoriz))  !Total Number of Compartments
    IF (NCOM2+1 .GT. NCMPTS) THEN
      write(EchoFileUnit,*)'Too many compartments; Max = ', NCMPTS
      stop
    ENDIF
    
    !*** Populate Soil Depth Vecor *********
    soil_depth = 0.0
    soil_depth(1) = delx(1)
    do i=2, NCOM2
       soil_depth(i) = soil_depth(i-1) + delx(i) 
    end do
 
    !*** Calculate Runoff Depth   ****************
    
    cn_moist_node = find_depth_node(ncom2,soil_depth,CN_moisture_depth)
    
    !*** Find the node for the ANETD ***************

    NCOM0 =  find_depth_node(ncom2,soil_depth,anetd)
    
    
    !Find the node for user-specified irrigation depth
      If (UserSpecifiesDepth) then
          user_irrig_depth_node =  find_depth_node(ncom2,soil_depth,user_irrig_depth)
      end if
    
    
    
    
    !initialize the water content in the profile to the THETO (previously initailized in SUBROUTINE INIACC)
    THETN = THETO   
 
    OUTPUJ=0.0   !output accumulators, only used in output, could be initialzed with save attribute there
    OUTPJJ=0.0

    !initializehenry's law constant for first time here
    do K = 1, NCHEM
      do I = 1,NCOM2
        OKH(K,I) = HENRYK(K)
      end do
    end do
    
    do I=1,NHORIZ
        THETAS(I)=1.0-BD(I)/2.65
        !   check that calculated THEFC is less than THETAS (carried overfrom THCALC)
        IF (THEFC(I) > THETAS(I)) THEN
          WRITE(EchoFileUnit,* ) "Horizion No. ", NHORIZ, 'Water capacity exceeds saturation.', THETAS(I)
           stop
        ENDIF
    end do
 
     
     startday = jd(ISTYR,ISMON,ISDAY)

     !dfy September 19, 2012
     !changed to less than or equal to prevent jan 1 error for emergence dats                   
     ! IF ((ISTYR. LT. IYREM(1)) .OR. (ISTYR .EQ. IYREM(1)
     !1     .AND. (SJDAY .LT. IEMER(1))     )) THEN  !******************

     
     if (startday <= emergence_date(1)) then
        !this part of code executed if simulation start date is before first crop emergence date  
        NCP  = 0
        RZI  = 0
        NDCNT= 0
        
        do I=1,Num_Crops
          IF (INICRP .EQ. ICNCN(I)) NCROP = I
        end do
     ELSE          
        !this part of code is executed if simulation start date is after first crop emergence date
        !find crop number of current crop at beginning of simulation
        RZI = 1
        NCP = 0
        I= 1
    
        ! do until NCP has a value or I= NCPDS
        do  !Find the first emergence date after the the startdate.        
           if (startday <= emergence_date(i)) then
           !  IF ((ISTYR .LT. IYREM(I)) .OR.(ISTYR .EQ. IYREM(I) .AND. SJDAY .LE. IEMER(I))) THEN
             NCP = I-1
             do J=1,Num_Crops              
                !*******************************************   
                !There is another problem here.  IF Emeregence is set to January 1, then INCROP(NCP=0) will be out of bounds
                !Apparently the Lahey compiler ignores this error
                !*******************************************                      
                IF (INCROP(NCP) .EQ. ICNCN(J)) NCROP=J
             end do
           ENDIF
           I= I+ 1
           IF (NCP /= 0 .OR. I .GT. NCPDS) exit
        end do 
        
        IF (NCP .EQ. 0) THEN
          NCP = NCPDS
          NCROP = INCROP(NCP)
        ENDIF
           
        !find the total number of days from emergence date to crop maturity for beginning crop

        !Replacement for the previoyus confusing code.
        !untested, so needs to be checked if used
        if (startday >= harvest_date(ncp)) then 
          RZI= 0
          NDCNT= 0
        else    
          NDCNT = emergence_date(NCP) - startday +1
        end if

      ENDIF 

      

     
      
     

     !**** Initialization of Curve Number and Erosion parameters*****  
     select case (use_usleyears) 
     case (1)  !Erosion Parameters and Curve Numbers are Year Specific
           CN_index = 1  
           !For case 1, JUSLEC is referenced to Jan 1, 1900
            do K=1,Num_Crops     
              do I=1,NUSLEC(K)  
                 JUSLEC(K,I)= jd(GYUSLEC(K,I),GMUSLEC(K,I),GDUSLEC(K,I))       
              end do 
            end do

           smallest_difference = 1e6
           do i= 1,NUSLEC(NCROP)
               day_difference =  abs(startday - JUSLEC(NCROP,i))
               if (day_difference < smallest_difference) then
                  smallest_difference = day_difference
                  CN_index = i   !This sets the index for initial CN and erosion parameters
               end if    
           end do

     case default  !Erosion Parameters and Curve Numbers  repeat every year
           !For default case JUSLEC is referenced to the Jan 1 of any year
           
           startday_doy = startday - jd(istyr,1,1)+1  
           do K=1,Num_Crops     
              do I=1,NUSLEC(K)  
                 JUSLEC(K,I)= jd(1,GMUSLEC(K,I),GDUSLEC(K,I)) -jd(1,1,1) +1        
              end do 
           end do
          
           smallest_difference = 1000
           do i= 1,NUSLEC(NCROP)
               if (JUSLEC(NCROP,i) > startday_doy) then
                 day_difference =  startday_doy - (JUSLEC(NCROP,i)-365)
               else
                 day_difference =  startday_doy - JUSLEC(NCROP,i)   
               end if
               
               if (day_difference < smallest_difference) then
                   smallest_difference = day_difference  
                   CN_index = i   !This sets the index for initial CN and erosion parameters
               end if
           enddo
           cfac = USLEC(NCROP,CN_index)
           n1 = MNGN(NCROP,CN_index)
           !***************************************************** 
     end select
     
     
     
     !******  PROBABLY CAN GET RID OF ALL THIS MODFC STUFF since copartments are now exact! ********

      !determine number of compartments in each horizon, use this number for distributing fractions and storages from nitrogen
      !inputs in each horizon equally to the compartments within
    

      
     
      
      
! TOO CONFUSING ! need straightening out      
!     assign horizon soil profile values to individual soil layers
      IB = NHORIZ
      T  = 0.0
      TTHKNS = THKNS(IB)

      U=0.0
      do J = 1, NCOM2-1
          IBM1= IB - 1
          JB  = NCOM2 - J + 1
          T   = T + DELX(JB)
          U = U + DELX(J)
          MODFC  = 0.0
          IF (T .LE. TTHKNS+.01) THEN
              BD(JB)    = BD(IB)
              THETAS(JB)= THETAS(IB)
              THETO(JB) = THETO(IB)
              THEFC(JB) = THEFC(IB)
              THEWP(JB) = THEWP(IB)
         !     HORIZN(JB)= HORIZN(IB)
              SAND(JB)  = SAND(IB)
              CLAY(JB)  = CLAY(IB)
              OC(JB)    = OC(IB)
              SPT(JB)   = SPT(IB)
              THCOND(JB)= THCOND(IB)
              VHTCAP(JB)= VHTCAP(IB)
              DKRW12(JB)= DKRW12(IB)
              DKRW13(JB)= DKRW13(IB)
              DKRW23(JB)= DKRW23(IB)

              do K=1, NCHEM
                  DWRATE(K,JB) = DWRATE(K,IB)
                  DSRATE(K,JB) = DSRATE(K,IB)
                  DGRATE(K,JB) = DGRATE(K,IB)
   
                  DISP(K,JB)   = DISP(K,IB)
              end do       
          ELSE   
              MODFC     = (T - TTHKNS) / DELX(JB)
              BD(JB)    = BD(IB)    * (1.0-MODFC)+ BD(IBM1)    * MODFC
              THETAS(JB)= THETAS(IB)* (1.0-MODFC)+ THETAS(IBM1)* MODFC
              THETO(JB) = THETO(IB) * (1.0-MODFC)+ THETO(IBM1) * MODFC
              THEFC(JB) = THEFC(IB) * (1.0-MODFC)+ THEFC(IBM1) * MODFC
              THEWP(JB) = THEWP(IB) * (1.0-MODFC)+ THEWP(IBM1) * MODFC
        !      HORIZN(JB)= HORIZN(IBM1)
              SAND(JB)  = SAND(IB)  * (1.0-MODFC)+ SAND(IBM1)  * MODFC
              CLAY(JB)  = CLAY(IB)  * (1.0-MODFC)+ CLAY(IBM1)  * MODFC
              OC(JB)    = OC(IB)    * (1.0-MODFC)+ OC(IBM1)    * MODFC
              SPT(JB)   = SPT(IB)   * (1.0-MODFC)+ SPT(IBM1)   * MODFC
              THCOND(JB)= THCOND(IB)* (1.0-MODFC)+ THCOND(IBM1)* MODFC
              VHTCAP(JB)= VHTCAP(IB)* (1.0-MODFC)+ VHTCAP(IBM1)* MODFC
              DKRW12(JB)= DKRW12(IB)* (1.0-MODFC)+ DKRW12(IBM1)* MODFC
              DKRW23(JB)= DKRW23(IB)* (1.0-MODFC)+ DKRW23(IBM1)* MODFC
              DKRW13(JB)= DKRW13(IB)* (1.0-MODFC)+ DKRW13(IBM1)* MODFC

              do K=1, NCHEM
                  DWRATE(K,JB)= DWRATE(K,IB)*(1.0-MODFC)+DWRATE(K,IBM1)*MODFC
                  DSRATE(K,JB)= DSRATE(K,IB)*(1.0-MODFC)+DSRATE(K,IBM1)*MODFC
                  DGRATE(K,JB)= DGRATE(K,IB)*(1.0-MODFC)+DGRATE(K,IBM1)*MODFC
                  DISP(K,JB)  = DISP(K,IB)*(1.0-MODFC) + DISP(K,IBM1)*MODFC
              end do
              IB = IB - 1
              TTHKNS = TTHKNS + THKNS(IB)
          ENDIF
      end do
      
      
    

      !Calculate Soil moisture in top 10 cm
      THETH  = 0.0
      do I=1,cn_moist_node
        THETH = THETH + 0.5*(THEFC(I)+THEWP(I))
      end do
     
      THETH = THETH/cn_moist_node
      do I=1,NCOM2
        SoilWater(I) = THETO(I)*DELX(I)
        FC(I) = THEFC(I)*DELX(I)
        WP(I) = THEWP(I)*DELX(I)
      end do

      !***  Find the Maximum Root Node **********
      rzd = maxval(AMXDR(1:num_crops))
      NCOMRZ = find_depth_node(ncom2,soil_depth,rzd)

      
      !*** EXTRACTION of RUNOFF AND EROSION FROM SOIL ****************************
         !** Runoff Extraction Intensity
         RNCMPT =  find_depth_node(ncom2,soil_depth,runoff_extr_depth) !Calculate number of compartments which make up runoff
         runoff_intensity=0.0   

         
     if (runoff_decline > 0.0001) then
      do I=1,RNCMPT
        delx_avg_depth =  soil_depth(i) - DELX(I)/2.
        runoff_intensity(I)=runoff_effic*runoff_decline/(1-exp(-runoff_decline*runoff_extr_depth)) &
                            *exp(-runoff_decline*delx_avg_depth)
      end do  
    else 
       runoff_intensity(1:rncmpt)=runoff_effic/runoff_extr_depth
    end if
    

         
         !** Erosion Extraction Intensity    
         erosion_compt =  find_depth_node(ncom2,soil_depth,erosion_depth) !Calculate number of compartments which make up runoff
         erosion_intensity=0.0   

         if (erosion_decline > 0.0001) then
             do i=1,erosion_compt
                delx_avg_depth =  soil_depth(i) - DELX(I)/2.
                erosion_intensity(i)=erosion_decline/(1.0-exp(-erosion_decline*erosion_depth))*exp(-erosion_decline*delx_avg_depth)
             end do   
         else !essentially no decline uniform extraction
             erosion_intensity(1:erosion_compt) = 1.0/erosion_depth
         end if
         
   

!     perform units conversions for input variables
!     COVMAX..PERCENT--->FRACTION
!     WFMAX...KG/M**2--->G/CM**2
!     TAPP... KG/HA  --->G/CM**2

      COVMAX = COVMAX/100.
      WFMAX = WFMAX/10.   
      TAPP=TAPP/1.0E5
     

     DO I = 1, NAPS
         DO K = 1, NCHEM
            Select Case(CAM(K,I))
            Case(1:3)
                DEPI(K,I) = cam123_soil_depth
            Case(4:10)
                  If (DEPI(K,I) < delx(1)) Then
                      DEPI(K,I) = delx(1)
                      write (EchoFileUnit,*) 'Note: Minimum incorporation = ', Delx(1)
                  End If
            Case Default
                  note = 'CAM value is unheard of.'
                  FATAL = .True.
                  CALL ERRCHK(note,FATAL)
            End Select
         End Do
      End Do

  end subroutine INITL
      

  
  Subroutine Calculate_CurveNumbers_1and3
  ! Given CN 2 from the inputs filem, this will calculate and load CN 1 and CN 3 into constants_and_Variables module
  use constants_and_Variables, ONLY: NUSLEC,Num_Crops,CN_input, CN_2

    implicit none
    real    :: RMULT1(10) = [0.40,0.45,0.50,0.55,0.62,0.67,0.73,0.79,0.87,1.00]
    real    :: RMULT3(10) = (/2.22,1.85,1.67,1.50,1.40,1.30,1.21,1.14,1.07,1.00/)
    integer :: k,j,JP1T10,jp1,JT10, km
    real    :: frac
    !generate curve numbers for antecedent conditions I and III
                                 
     CN_input(:,:,2) = CN_2   
           
     

     do KM=1,Num_Crops           
                  
         do K=1,NUSLEC(KM)
            do J=1,9
              JT10=J*10
              JP1=J+1
              JP1T10=JP1*10
              IF (CN_input(KM,K,2).GT.JT10 .AND. CN_input(KM,K,2).LE.JP1T10) THEN
                 FRAC=(CN_input(KM,K,2)-JT10)/10.
                 CN_input(KM,K,1)=((RMULT1(JP1)-RMULT1(J))*FRAC+RMULT1(J)) *CN_input(KM,K,2)
                 CN_input(KM,K,3)=((RMULT3(JP1)-RMULT3(J))*FRAC+RMULT3(J)) *CN_input(KM,K,2)
                 
              End If
            end do 
         end do 
     end do
     

  end Subroutine Calculate_CurveNumbers_1and3
  
      
end module initialization   