Module Output_File
    implicit none
    contains
    
      SUBROUTINE OUTTSR(SRNFG,HEIGHT)
      use  constants_and_Variables, ONLY: NAPP,NC, NCMPTS,TimeSeriesUnit, PRECIP, snowfl,spt,THRUFL,IRRR,SoilWater,cint,et,delx, &
       thetn, CEVAP ,runof ,cvnum,thetas,ainf,ncom2,snow,sedl,TDET,PVFLUX,DFFLUX,adflux,sdkflx,SUPFLX,UPFLUX,KD,pestr,   &
       SPESTR,SOILAP, FOLPST,FPDLOS,KH,FPVLOS,PLNTAP,NCHEM,TCNC,CRPAPP,DKFLUX,ERFLUX, WOFLUX,ROFLUX,RZFLUX,const,OUTPUJ,    &
       OUTPJJ,INDX,NPLOTS, IARG,IARG2,current_year,PLNAME,MODE,header,current_day,current_month,DCOFLX

!     Outputs user specified time series to time series plotting files
      implicit none
      INTEGER     SRNFG
      REAL        HEIGHT

      INTEGER     I,IARG1,CPLTFL,K,ID1,NUMCOM,MIDCOM1,MIDCOM2,IARG3
      real :: OUTPUT(12)
      

      REAL   PNBRN(12),RMULT,XSOIL(3),PRTBUF(12)
      REAL   TTTOT,DPTOT,DELTOT,SPSTRT,SPWGHT,SPTOT
      REAL   CMTOT,CMDPTH,CMSS1
      CHARACTER(len=4) :: INTS,SWTR,SNOP,THET,PRCP,SNOF,THRF,INFL,RUNF,CEVP,TETD,ESLS,FPST,TPST,SPST,TPAP,FPDL,WFLX,DFLX,AFLX
      CHARACTER(len=4) :: UFLX,RFLX,EFLX,RZFX,TUPX,TDKF,TSER,TCUM,COFX,VFLX,PRTNAM(12),SLET,DKFX,STMP,CHGT,PCNC,FPVL,TSUM,TAVE
      CHARACTER(len=4) :: DCON,ACON,GCON,TCON,DLYS,CMSS,INCS,CURV,IRRG


      DATA INTS/'INTS'/,SWTR/'SWTR'/,THET/'THET'/,PRCP/'PRCP'/,SNOF/'SNOF'/,THRF/'THRF'/,INFL/'INFL'/,RUNF/'RUNF'/,  &
           CEVP/'CEVP'/,SLET/'SLET'/,TETD/'TETD'/,ESLS/'ESLS'/,FPST/'FPST'/,TPST/'TPST'/,SPST/'SPST'/,TPAP/'TPAP'/,  &
           FPDL/'FPDL'/,WFLX/'WFLX'/,DFLX/'DFLX'/,AFLX/'AFLX'/,DKFX/'DKFX'/,UFLX/'UFLX'/,RFLX/'RFLX'/,EFLX/'EFLX'/,  &
           RZFX/'RZFX'/,TUPX/'TUPX'/,TDKF/'TDKF'/,TSER/'TSER'/,TCUM/'TCUM'/,SNOP/'SNOP'/,STMP/'STMP'/,CHGT/'CHGT'/,  &
           VFLX/'VFLX'/,PCNC/'PCNC'/,FPVL/'FPVL'/,COFX/'COFX'/,TSUM/'TSUM'/,TAVE/'TAVE'/,IRRG/'IRRG'/
      
      DATA DCON/'DCON'/,ACON/'ACON'/,GCON/'GCON'/,TCON/'TCON'/,DLYS/'DLYS'/,CMSS/'CMSS'/,INCS/'INCS'/,CURV/'CURV'/
      


2000  FORMAT (1X,A3,21X,12(5X,A4,A1,4X))

      CPLTFL = 0

!     Section added to sum up soilap, see below

      DO K=1,NCHEM
        XSOIL(K) = 0.00
        DO I = 1, NCOM2
          XSOIL(K) = XSOIL(K) + SOILAP(K,I)
        END DO
      END DO

! *** Section added to sum up lateral outflow of water, ATC 8/93 ***

      !OUTFLOW = 0.0
      !DO I = 1,NCOM2
      !   OUTFLOW = OUTFLOW + OUTFLO(I)
      !END DO

! ******************************************************************

      DO I=1,NPLOTS
        IARG1= IARG(I)
        IARG3= IARG2(I)
        ID1 = 1
        IF (INDX(I) .EQ. '2') ID1 = 2
        IF (INDX(I) .EQ. '3') ID1 = 3
        OUTPUT(I)= 0.
        DPTOT=0.0
        TTTOT=0.0


!wei  changed code to allow summation/averaging of multiple compartments

        IF ((MODE(I).EQ.TAVE).OR.(MODE(I).EQ.TSUM))THEN
!         Water storages  (units of CM)
          IF (PLNAME(I) .EQ. SWTR)THEN
             do K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+SoilWater(K)*DELX(K)
               ELSE
                 TTTOT= TTTOT+SoilWater(K)
               ENDIF
             end do
             PNBRN(I)=TTTOT
!         Water fluxes (units of CM/DAY)
          ELSEIF (PLNAME(I) .EQ. INFL)THEN
             do K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+AINF(K)*DELX(K)
               ELSE
                 TTTOT= TTTOT+AINF(K)
               ENDIF
             end do
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. SLET)THEN
             do K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+ET(K)*DELX(K)
               ELSE
                 TTTOT= TTTOT+ET(K)
               ENDIF
             end do
             PNBRN(I)=TTTOT
!         Soil temperature (oC)
          ELSEIF (PLNAME(I) .EQ. STMP)THEN
             do K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT=TTTOT+SPT(K)*DELX(K)
               ELSE
                 TTTOT=TTTOT+SPT(K)
               ENDIF
             end do
             PNBRN(I)=TTTOT
!         Pesticide storages (units of GRAMS/(CM**2)
          ELSEIF (PLNAME(I) .EQ. TPST)THEN
          
             DO K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT=TTTOT+(PESTR(ID1,K)*DELX(K)*THETN(K))*DELX(K)
               ELSE
                 TTTOT=TTTOT+(PESTR(ID1,K)*DELX(K)*THETN(K))        
               ENDIF
             END DO
      
           
             PNBRN(I)=TTTOT
    
          ELSEIF (PLNAME(I) .EQ. SPST)THEN
             DO 65 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT=TTTOT+(SPESTR(ID1,K)*DELX(K)*THETN(K))*DELX(K)
               ELSE
                 TTTOT=TTTOT+(SPESTR(ID1,K)*DELX(K)*THETN(K))
               ENDIF
 65          CONTINUE
             PNBRN(I)=TTTOT
!         Pesticide fluxes (units of GRAMS/(CM**2-DAY)
          ELSEIF (PLNAME(I) .EQ. DFLX)THEN
             DO 66 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+DFFLUX(ID1,K)*DELX(K)
               ELSE
                 TTTOT= TTTOT+DFFLUX(ID1,K)
               ENDIF
 66          CONTINUE
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. AFLX)THEN
             DO 67 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+ADFLUX(ID1,K)*DELX(K)
               ELSE
                 TTTOT= TTTOT+ADFLUX(ID1,K)
               ENDIF
 67          CONTINUE
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. DKFX)THEN
             DO 68 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+DKFLUX(ID1,K)*DELX(K)
               ELSE
                 TTTOT= TTTOT+DKFLUX(ID1,K)
               ENDIF
 68          CONTINUE
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. UFLX)THEN
             DO 69 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+UPFLUX(ID1,K)*DELX(K)
               ELSE
                 TTTOT= TTTOT+UPFLUX(ID1,K)
               ENDIF
 69          CONTINUE
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. DCON)THEN
             DO 70 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+(SPESTR(ID1,K)*1.E6)*DELX(K)
               ELSE
                 TTTOT= TTTOT+(SPESTR(ID1,K)*1.E6)
               ENDIF
 70          CONTINUE
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. ACON)THEN
             DO 71 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+((SPESTR(ID1,K)*1.E6)*KD(ID1,K))*DELX(K)
               ELSE
                 TTTOT= TTTOT+((SPESTR(ID1,K)*1.E6)*KD(ID1,K))
               ENDIF
 71          CONTINUE
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. GCON)THEN
             DO 72 K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+(((SPESTR(ID1,K)*1.E6)*KH(ID1,K)))*DELX(K)
               ELSE
                 TTTOT= TTTOT+(((SPESTR(ID1,K)*1.E6)*KH(ID1,K)))
               ENDIF
 72          CONTINUE
             PNBRN(I)=TTTOT
          ELSEIF (PLNAME(I) .EQ. TCON)THEN
             do K=IARG1,IARG3
               IF(MODE(I).EQ.TAVE)THEN
                 TTTOT= TTTOT+(SPESTR(ID1,K)*1.E6*THETN(K)+SPESTR(ID1,K)*1.E6*KD(ID1,K)+   &
                    SPESTR(ID1,K)*1.E6*KH(ID1,K)*(THETAS(K)-THETN(K)))*DELX(K)
               ELSE
                 TTTOT= TTTOT+(SPESTR(ID1,K)*1.E6*THETN(K)+SPESTR(ID1,K)*1.E6*KD(ID1,K)+   &
                      SPESTR(ID1,K)*1.E6*KH(ID1,K)*(THETAS(K)-THETN(K)))
               ENDIF
             end do
             PNBRN(I)=TTTOT

          ELSEIF (PLNAME(I) .EQ. DLYS)THEN
            SPTOT=0.0
            NUMCOM=(IARG3-IARG1)+1
            DELTOT=DELX(IARG1)*NUMCOM
            IF(MOD(NUMCOM,2).EQ.0)THEN
              SPSTRT=((DELTOT/2.0)-(DELX(IARG1)/2.0))/2.5
              IF(SPSTRT.LT.1.0)SPSTRT=1.0
              MIDCOM1=(IARG1+IARG3)/2
              MIDCOM2=MIDCOM1+1
            ELSE
              SPSTRT=((DELTOT/2.0)/2.5)
              IF(SPSTRT.LT.1.0)SPSTRT=1.0
              MIDCOM1=(IARG1+IARG3)/2
              MIDCOM2=MIDCOM1
            ENDIF
            DO 84 K=IARG1,IARG3
              SPWGHT=(2.0/((SPSTRT**2)+1.0))
              TTTOT= TTTOT+((SPESTR(ID1,K)*1.E6)*SPWGHT)
              SPTOT=SPTOT+SPWGHT
              IF(((K.LT.MIDCOM1).OR.(K.LT.MIDCOM2)).AND.((DELX(K)/2.5).GE.2.0))THEN
                SPSTRT=(DELX(K)/2.5)/2.0
              ELSEIF(((K.LT.MIDCOM1).OR.(K.LT.MIDCOM2)).AND.((DELX(K)/2.5).LT.2.0))THEN
                SPSTRT=1.0
              ELSEIF(((K.EQ.MIDCOM1).OR.(K.EQ.MIDCOM2)).AND.((DELX(K)/2.5).GE.2.0))THEN
                SPSTRT=(DELX(K)/2.5)/2.0
              ELSEIF(((K.EQ.MIDCOM1).OR.(K.EQ.MIDCOM2)).AND.((DELX(K)/2.5).LT.2.0))THEN
                SPSTRT=1.0
              ELSEIF(((K.GT.MIDCOM1).OR.(K.GT.MIDCOM2)).AND.((DELX(K)/2.5).GE.2.0))THEN
                SPSTRT=SPSTRT+(DELX(K)/2.5)
              ELSEIF(((K.GT.MIDCOM1).OR.(K.GT.MIDCOM2)).AND.((DELX(K)/2.5).LT.2.0))THEN
                SPSTRT=1.0
              ENDIF
 84         CONTINUE
            PNBRN(I)=TTTOT
            
            
            
          ELSEIF (PLNAME(I) .EQ. CMSS)THEN    !cmss is not documented
             CMDPTH=0.0
             DO 85 K=IARG1,IARG3
               TTTOT=TTTOT+(PESTR(ID1,K)*DELX(K)*THETN(K))*DELX(K)
 85          CONTINUE
             CMTOT=0.0
             CMSS1=TTTOT/2.
             TTTOT=0.0
             DO 86 K=IARG1,IARG3
               CMTOT=CMTOT+DELX(K)
               TTTOT=TTTOT+(PESTR(ID1,K)*DELX(K)*THETN(K))*DELX(K)
               IF(TTTOT.EQ.0.0)THEN
                 CMDPTH=0.0
               ELSEIF(TTTOT.LE.CMSS1)THEN
                 CMDPTH=CMTOT
               ENDIF
 86          CONTINUE
             PNBRN(I)=CMDPTH
          ELSEIF (PLNAME(I) .EQ. INCS)THEN   !INCS is not documented
             TTTOT=0.0
             CMTOT=0.0
             CMDPTH=0.0
             
             do  K=IARG1,IARG3
               CMTOT=CMTOT+DELX(K)
               TTTOT=(PESTR(ID1,K)*DELX(K)*THETN(K))*DELX(K)
               IF(TTTOT.GT.CONST(I))CMDPTH=CMTOT              !the use of CONST doesnt make sence to me here
             end do
             
             
             PNBRN(I)=CMDPTH
          ENDIF
          

          
        ELSE
          IF (PLNAME(I) .EQ. SWTR) PNBRN(I)= SoilWater(IARG1)
!         Soil water storages (dimensionless)
          IF (PLNAME(I) .EQ. THET) PNBRN(I)= THETN(IARG1)
!         Water fluxes (units of CM/DAY)
          IF (PLNAME(I) .EQ. INFL) PNBRN(I)= AINF(IARG1)
          IF (PLNAME(I) .EQ. SLET) PNBRN(I)= ET(IARG1)
!         Soil temperature (oC)
          IF (PLNAME(I) .EQ. STMP) PNBRN(I)=SPT(IARG1)
!         Pesticide storages (units of GRAMS/(CM**2)
          IF (PLNAME(I) .EQ. TPST) PNBRN(I)=PESTR(ID1,IARG1)*DELX(IARG1)*THETN(IARG1)
     
     
          IF (PLNAME(I) .EQ. SPST) PNBRN(I)=SPESTR(ID1,IARG1)*THETN(IARG1)*DELX(IARG1)
!         Pesticide fluxes (units of GRAMS/(CM**2-DAY)
          IF (PLNAME(I) .EQ. DFLX) PNBRN(I)= DFFLUX(ID1,IARG1)
          IF (PLNAME(I) .EQ. AFLX) PNBRN(I)= ADFLUX(ID1,IARG1)
          IF (PLNAME(I) .EQ. DKFX) PNBRN(I)= DKFLUX(ID1,IARG1)
          IF (PLNAME(I) .EQ. UFLX) PNBRN(I)= UPFLUX(ID1,IARG1)
          IF (PLNAME(I) .EQ. DCON) PNBRN(I)= SPESTR(ID1,IARG1)*1.E6
          IF (PLNAME(I) .EQ. ACON) PNBRN(I)= SPESTR(ID1,IARG1)*1.E6 *KD(ID1,IARG1)
          IF (PLNAME(I) .EQ. GCON) PNBRN(I)= SPESTR(ID1,IARG1)*1.E6*KH(ID1,IARG1)
          IF (PLNAME(I) .EQ. TCON) PNBRN(I)=SPESTR(ID1,IARG1)*1.E6*THETN(IARG1)+SPESTR(ID1,IARG1)*1.E6*KD(ID1,IARG1)+  &
                 SPESTR(ID1,IARG1)*1.E6*KH(ID1,IARG1)*(THETAS(IARG1)-THETN(IARG1))
        ENDIF

        
        
!       Water storages  (units of CM)
        IF (PLNAME(I) .EQ. INTS) PNBRN(I)= CINT
        IF (PLNAME(I) .EQ. SNOP) PNBRN(I)= SNOW

!       Water fluxes (units of CM/DAY)
        IF (PLNAME(I) .EQ. PRCP) PNBRN(I)= PRECIP
        IF (PLNAME(I) .EQ. IRRG) PNBRN(I)= IRRR
        IF (PLNAME(I) .EQ. SNOF) PNBRN(I)= SNOWFL
        IF (PLNAME(I) .EQ. THRF) PNBRN(I)= THRUFL
        IF (PLNAME(I) .EQ. RUNF) PNBRN(I)= RUNOF
        

        
        IF (PLNAME(I) .EQ. CEVP) PNBRN(I)= CEVAP
        IF (PLNAME(I) .EQ. TETD) PNBRN(I)= TDET
        
!       IF (PLNAME(I) .EQ. OUTF) PNBRN(I)= OUTFLOW
        
        IF (PLNAME(I) .EQ. CURV) PNBRN(I)= CVNUM

!       Sediment flux (units of KG/DAY)
        IF (PLNAME(I) .EQ. ESLS) PNBRN(I)= SEDL
        


!       Canopy height (CM)
        IF (PLNAME(I) .EQ. CHGT) PNBRN(I)=HEIGHT

!       Pesticide storages (units of GRAMS/(CM**2)
        IF (PLNAME(I) .EQ. FPST) PNBRN(I)=FOLPST(ID1)
        IF (PLNAME(I) .EQ. PCNC) PNBRN(I)=TCNC(ID1)

!       Pesticide fluxes (units of GRAMS/(CM**2-DAY)
! CRPAPP is used to determine whether the application was caused
! by harvest (IPSCND=1).  This check will prevent double counting
! of the application. JMC 2/98
        IF (PLNAME(I) .EQ. TPAP)THEN
          IF(CRPAPP(ID1).EQ.0)THEN
            PNBRN(I)= XSOIL(ID1) + PLNTAP(ID1)
          ELSEIF(CRPAPP(ID1).EQ.1)THEN
            CRPAPP(ID1)=0
          ENDIF
        ENDIF
        IF (PLNAME(I) .EQ. FPDL) PNBRN(I)= FPDLOS(ID1)
        IF (PLNAME(I) .EQ. WFLX) PNBRN(I)= WOFLUX(ID1)
        IF (PLNAME(I) .EQ. RFLX) PNBRN(I)= ROFLUX(ID1)
        IF (PLNAME(I) .EQ. EFLX) PNBRN(I)= ERFLUX(ID1)
        IF (PLNAME(I) .EQ. RZFX) PNBRN(I)= RZFLUX(ID1)
        IF (PLNAME(I) .EQ. TUPX) PNBRN(I)= SUPFLX(ID1)
        IF (PLNAME(I) .EQ. TDKF) PNBRN(I)= SDKFLX(ID1)
        IF (PLNAME(I) .EQ. COFX) PNBRN(I)= DCOFLX(ID1)*1.E-5

!       Add VFLX option to plot PVFLUX
        IF (PLNAME(I) .EQ. VFLX) PNBRN(I)= -PVFLUX(ID1,1)
        IF (PLNAME(I) .EQ. FPVL) PNBRN(I)= FPVLOS(ID1)

!       Change units of output using user supplied constant
      RMULT= CONST(I)
      
!DFY: get rid of the min value
!        IF(ABS(CONST(I)).LT.1.0E-5) THEN
!!         default 1.0
!          RMULT= 1.0
!        ELSE
!!         Use user specified value
!          RMULT= CONST(I)
!        ENDIF
   
        
        
        IF(PLNAME(I).EQ.INCS)THEN
          RMULT= 1.0
        ENDIF
        PNBRN(I)= PNBRN(I)* RMULT

        IF((MODE(I).EQ.TSER).OR.(MODE(I).EQ.TSUM))THEN
          OUTPUT(I)= PNBRN(I)
        ELSEIF (MODE(I).EQ.TCUM) THEN
!         Accumulate output variable if a cumulative plot is requested
          IF (SRNFG.EQ.1) THEN
            OUTPJJ(I)= PNBRN(I)
          ELSE
            OUTPUJ(I)= OUTPUT(I)+ PNBRN(I)
            OUTPJJ(I)= OUTPJJ(I)+ OUTPUJ(I)
          ENDIF
        ELSEIF(MODE(I).EQ.TAVE)THEN
!         Accumulate Total Depth for use in depth weighted average
          DO   K=IARG1,IARG3
             DPTOT=DPTOT+DELX(K)
          end do
          IF(PLNAME(I).EQ.DLYS)THEN
            OUTPUT(I)=PNBRN(I)/SPTOT
          ELSE
            OUTPUT(I)=PNBRN(I)/DPTOT
          ENDIF
        ENDIF


!C         Printer plot to file

          CPLTFL= CPLTFL+ 1
          IF ((MODE(I).EQ.TSER).OR.(MODE(I).EQ.TSUM).OR.(MODE(I).EQ.TAVE))PRTBUF(CPLTFL)= OUTPUT(I)
          IF (MODE(I).EQ.TCUM) PRTBUF(CPLTFL)= OUTPJJ(I)
          IF (SRNFG.EQ.1) PRTNAM(CPLTFL)= PLNAME(I)
       end do


      IF (CPLTFL.GT.0 .AND. TimeSeriesUnit.GT.0) THEN

        IF (HEADER .EQ. 1) THEN
          WRITE(TimeSeriesUnit,*)'United States of America, EPA PRZM 5'  
          WRITE(TimeSeriesUnit,*)  
                    
          WRITE(TimeSeriesUnit,'(19x, 12(A4,A1,9X))') (PRTNAM(I),INDX(I),I=1,CPLTFL)     
          
        END IF
      WRITE(TimeSeriesUnit,18) current_year,current_month,current_day,(PRTBUF(I),I=1,CPLTFL)  
18    FORMAT (I2,2I3,6X,12(2X,G12.4))          

      END IF
      ENDSUBROUTINE OUTTSR
      
end Module Output_File
      