PROGRAM   PRZM5
   use constants_and_Variables, ONLY: EchoFileUnit,maxFileLength,calibrationFlag,RunFilePath
   use PRZM_VERSION
   use initialization
   use utilities
   use readinputs
   use PRZM_core
   use calibration
   implicit none
   
   integer :: i , IERROR, total_days,status

   Character(Len=maxFileLength) :: filename

   !Command line may contain a path to the runfile, else path is the working default path
   Call GetArgs (RunFilePath)

          
   !KECHO.prn records the operating status of PRZM during runtime
   filename =  trim(RunFilePath) //  'KECHO.PRN'     
   OPEN(Unit=EchoFileUnit,FILE=Filename,STATUS='UNKNOWN',IOSTAT=IERROR)   
   call przm_id(EchoFileUnit)

  ! CALL read_run_file(RunFilePath)


   CALL PRZMRD_PRZM5   !read PRZM INPUT FILE

         
   CALL INITL    !initialize variables   
    
   if (calibrationFlag) then
       call read_calibration_data
   end if

   i=0

   
   
   do                         !day loop driven metfile only         
      CALL GETMET(status)     !daily met file read, status = -1 means end of file

        if (status /=0 )then
             total_days = i+1
             write (EchoFileUnit,*) "Total days = ", i
             exit
        end if
        i=i+1   !day counter
      CALL PRZM 
   end do
   write(EchoFileUnit,*) 'PRZM5 program normal completion.'

   if (calibrationFlag) then
       call write_calibration_data
   end if
   
END PROGRAM PRZM5