module plantgrowth
    implicit none
    contains
    
   !***************************************************************************
   SUBROUTINE PLGROW(julday1900)
       use constants_and_Variables, ONLY: NAPP,NC,MXCPD,NCMPTS,thrufl,cintcp,covmax,amxdr,ncpds,WFMAX,htmax,       &
           COVER,WEIGHT,HEIGHT,Num_Crops,INCROP,ncrop,IFSCND, icncn,ipscnd,ncp, &
           DELX,erflag,potential_canopy_holdup, ncom1,ncom0,nrzcomp,gamma1,UPTKF,NCHEM,NDCNT,RZI,current_year,    &
           emergence_date, maturity_date, harvest_date
       implicit none
       
       !determines plant growth parameters for use in other routines
       integer,intent(in) :: julday1900

       ! LOCAL VARIABLES
       REAL         FRAC,DDLN
       INTEGER      I,J
       integer ::   icount
      
       integer ::  TNDGS(MXCPD)

       do I= 1, NCPDS
           if (julday1900 == emergence_date(i)) then
               RZI = 1
               NDCNT=0
               
               !Not sure what this is about.  Accounts for some kind of disorder?
               DO J= 1, Num_Crops
                    !incrop is the crop number with the emergence date,
                    !icncn is the number for the crop properties
                    !THIS NEEDS Reworking
                   IF (INCROP(I) .EQ. ICNCN(J))THEN 
                      NCROP=J
                   ENDIF
               END DO
               
               NCP  = I
              tndgs(i)= maturity_date(i)- emergence_date(i)                         
           ENDIF
       end do
  
!     determine fraction of time elapsed between crop emergence and
!     maturation and compute crop growth parameters
      FRAC  = 0.
      COVER = 0.
      WEIGHT= 0.
      HEIGHT= 0.
      NCOM1 = NCOM0
      potential_canopy_holdup   = 0.
       
      IF (NCP .NE. 0 .AND. RZI .NE. 0) THEN
           NDCNT = NDCNT+1
           FRAC  = AMIN1(1.0,FLOAT(NDCNT)/FLOAT(TNDGS(NCP)))
           COVER = COVMAX(NCROP)*FRAC
           WEIGHT= WFMAX(NCROP)*FRAC
           HEIGHT= HTMAX(NCROP)*FRAC
           
           Icount = 0
           DDLN = 0.0
           
           do   !find depth to be used as root depth
               icount = icount +1
               ddln = ddln + delx(icount)
      
               if(ddln >= amxdr(ncrop)*frac) exit
           end do
          
           NRZCOMP = icount
           NCOM1 = AMAX1 (FLOAT(NRZCOMP),FLOAT(NCOM0))+ 0.5
           potential_canopy_holdup   = CINTCP(NCROP)*COVER

          !*****************HARVEST******************************************        
          !set soil surface condition after harvest and turn off root zone flag      
          if (julday1900 == harvest_date(NCP)) then
               RZI   = 0                               ! set root zone flag to no crop
               IFSCND(1:NCHEM,NCROP) = IPSCND(1:NCHEM) ! After Harvest pesticide disposition
               COVER  = 0.0
               HEIGHT = 0.0
               WEIGHT = 0.0
               potential_canopy_holdup    = 0.0 ! reset to eliminate crop interception
           ENDIF

          !set uptake flags if crop is growing
          IF (RZI .NE. 0) THEN
               do I=1,NRZCOMP
                   GAMMA1(:,I)= UPTKF(:)
               end do
          ENDIF
      ENDIF
   end Subroutine PLGROW
   
end module plantgrowth
    